/*
	ProWesS, PROGS Windowing System

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
*/

#include "sms_h"
#include "mem_h"
#include "str_h"
#include "ProWesS_h"

#define MAX_LEN 40

typedef struct { int count; PWObject object; } Aux;

Error exit(PWObject object)
{
	return PWChange(object,PW_SYSTEM_BREAKDOWN,NULL);
}

Error remove(PWObject object)
{
	return PWRemove(object);
}

Error add_item(PWObject object)
{
	Aux *aux;
	char *text;

	PWQuery(object,PW_OBJECT_AUXILIARY,&aux);
	(aux->count)++;
	MEMAllocate(MAX_LEN,&text);
	STRFormatPutSafe(text,MAX_LEN,"item %d",aux->count);
	return PWCreate(object,NULL,PW_TYPE_LOOSE_ITEM,
					PW_LOOSE_TEXT, text,
					PW_POSITION_BELOW, aux->object,
					PW_LOOSE_ACTION_DO, &remove,
					NULL);
}

void init()
{
	PWObject first;
	Aux aux;

	PWCreate(NULL,&first,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "add an item",
				PW_OBJECT_AUXILIARY,&aux,
				PW_LOOSE_ACTION_HIT, &add_item,
				NULL);
	aux.count=0;
	aux.object=first;
	PWCreate(first,NULL,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "quit",
				PW_POSITION_BELOW, first,
				PW_LOOSE_ACTION_HIT,&exit,
				NULL);
	PWActivate(first);
}
